Index: XIOS/trunk/xios_test_suite/TEST_SUITE/default_param.json
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/default_param.json	(revision 1923)
+++ XIOS/trunk/xios_test_suite/TEST_SUITE/default_param.json	(revision 1924)
@@ -1,12 +1,14 @@
 [
   {
-    "ATMdomain": "lmdz",
-    "UsingServer2": "true",
-    "RatioServer2": 50,
-    "NumberPoolsServer2": 1,
+    "Domain": "lmdz",
+    "DomMask": "false",
+    "AxisMask": "false",
+    "UseServer2": "true",
+    "PctServer2": 50,
     "Duration": "1d",
     "NumberClients": 4,
     "NumberServers": 4,
-    "InfoLevel": 100
+    "OneSided": "false",
+    "NonDistTran": "false"
   }
 ]
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/generate_new_reference.sh
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/generate_new_reference.sh	(revision 1923)
+++ 	(revision )
@@ -1,36 +1,0 @@
-#!/bin/bash
-revision=$(svn info --show-item revision ../ 2>&1)
-mkdir -p xios_reference
-for i in $(ls -d test_*)
-do
-  echo ${i%%}
-  mkdir -p xios_reference/${i%%}
-  for j in $(ls -d ${i%%}/config_*)
-  do
-    echo ${j%%}
-    mkdir -p xios_reference/${j%%}
-    DIR=${j%%}/tmp_reference
-    if [ -d "$DIR" ]; then
-      mv ${j%%}/tmp_reference ${j%%}/reference  
-    fi
-
-    cp -r ${j%%}/reference xios_reference/${j%%}
-    cp -r ${j%%}/setup xios_reference/${j%%}
-  done
-
-done
-
-cp -r ../ENV ./
-cp ../load_env ./
-source ./load_env
-#echo "xios_reference_dir" ${xios_reference_dir}
-
-mkdir -p ${xios_reference_dir}/xios_reference_archive
-mkdir -p ${xios_reference_dir}/xios_reference_archive/$(( ${revision}-1 ))
-mv ${xios_reference_dir}/xios_reference.tar.gz ${xios_reference_dir}/xios_reference_archive/$(( ${revision}-1 ))/
-
-tar -zcvf ${xios_reference_dir}/xios_reference.tar.gz xios_reference/
-rm -rf xios_reference
-
-rm -rf ENV
-rm -f load_env
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/generate_new_reference_irene_local.sh
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/generate_new_reference_irene_local.sh	(revision 1923)
+++ 	(revision )
@@ -1,29 +1,0 @@
-#!/bin/bash
-revision=$(svn info --show-item revision ../ 2>&1)
-mkdir -p xios_reference
-for i in $(ls -d test_*)
-do
-  echo ${i%%}
-  mkdir -p xios_reference/${i%%}
-  for j in $(ls -d ${i%%}/config_*)
-  do
-    echo ${j%%}
-    mkdir -p xios_reference/${j%%}
-    DIR=${j%%}/tmp_reference
-    if [ -d "$DIR" ]; then
-      mv ${j%%}/tmp_reference ${j%%}/reference  
-    fi
-
-    cp -r ${j%%}/reference xios_reference/${j%%}
-    cp -r ${j%%}/setup xios_reference/${j%%}
-  done
-
-done
-
-
-mkdir -p ${CCCWORKDIR}/xios_reference_archive
-mkdir -p ${CCCWORKDIR}/xios_reference_archive/$(( ${revision}-1 ))
-mv ${CCCWORKDIR}/xios_reference.tar.gz ${CCCWORKDIR}/xios_reference_archive/$(( ${revision}-1 ))/
-
-tar -zcvf ${CCCWORKDIR}/xios_reference.tar.gz xios_reference/
-rm -rf xios_reference
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/generate_new_reference_jeanzay_local.sh
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/generate_new_reference_jeanzay_local.sh	(revision 1923)
+++ 	(revision )
@@ -1,29 +1,0 @@
-#!/bin/bash
-revision=$(svn info --show-item revision ../ 2>&1)
-mkdir -p xios_reference
-for i in $(ls -d test_*)
-do
-  echo ${i%%}
-  mkdir -p xios_reference/${i%%}
-  for j in $(ls -d ${i%%}/config_*)
-  do
-    echo ${j%%}
-    mkdir -p xios_reference/${j%%}
-    DIR=${j%%}/tmp_reference
-    if [ -d "$DIR" ]; then
-      mv ${j%%}/tmp_reference ${j%%}/reference  
-    fi
-
-    cp -r ${j%%}/reference xios_reference/${j%%}
-    cp -r ${j%%}/setup xios_reference/${j%%}
-  done
-
-done
-
-
-mkdir -p ${WORK}/xios_reference_archive
-mkdir -p ${WORK}/xios_reference_archive/$(( ${revision}-1 ))
-mv ${WORK}/xios_reference.tar.gz ${WORK}/xios_reference_archive/$(( ${revision}-1 ))/
-
-tar -zcvf ${WORK}/xios_reference.tar.gz xios_reference/
-rm -rf xios_reference
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/iodef.xml
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/iodef.xml	(revision 1923)
+++ XIOS/trunk/xios_test_suite/TEST_SUITE/iodef.xml	(revision 1924)
@@ -7,7 +7,7 @@
 
       <variable id="timestep"> 1h </variable>
-      <variable id="domain"> XIOS::ATMdomain </variable>
-      <variable id="domain_mask"> false </variable>
-      <variable id="axis_mask"> false </variable>
+      <variable id="domain"> XIOS::Domain </variable>
+      <variable id="domain_mask"> XIOS::DomMask </variable>
+      <variable id="axis_mask"> XIOS::AxisMask </variable>
       <variable id="init_field2D"> rank </variable>
       <variable id="ni"> 36 </variable>
@@ -53,13 +53,13 @@
       <variable_group id="parameters" >
         <variable id="using_server" type="bool">true</variable>
-        <variable id="info_level" type="int">XIOS::InfoLevel</variable>
+        <variable id="info_level" type="int">100</variable>
         <variable id="print_file" type="bool">true</variable>
-        <variable id="using_server2" type="bool">XIOS::UsingServer2</variable>
-        <variable id="ratio_server2" type="int">XIOS::RatioServer2</variable>
-        <variable id="number_pools_server2" type="int">XIOS::NumberPoolsServer2</variable>
-        <variable id="pure_one_sided" type="bool">false</variable>
+        <variable id="using_server2" type="bool">XIOS::UseServer2</variable>
+        <variable id="ratio_server2" type="int">XIOS::PctServer2</variable>
+        <variable id="number_pools_server2" type="int">1</variable>
+        <variable id="pure_one_sided" type="bool">XIOS::OneSided</variable>
         <variable id="check_event_sync" type="bool">true</variable>
       </variable_group>
-      <variable id="activate_non_distributed_transformation" type="bool">false</variable>
+      <variable id="activate_non_distributed_transformation" type="bool">XIOS::NonDistTran</variable>
     </variable_definition>
   </context>
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/job_irene.sh
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/job_irene.sh	(revision 1923)
+++ 	(revision )
@@ -1,43 +1,0 @@
-#!/bin/bash
-
-export build_dir=xios_test_suite/RUN_TEST_SUITE/build_${arch}_${mode}
-export svnR=$(svn info --show-item revision ../../)
-
-echo "Start Building XIOS ... "
-bash -c "cd ../.. && ./make_xios --arch_path `pwd`/../ARCH --arch ${arch} --${mode} --build_dir ${build_dir} --job 4"
-
-export build_status=$?
-if [[ ${build_status} == 0 ]]
-then
-  echo "XIOS Build Finished. Start Unit Tests"
-  bash ./my_prod.sh
-  rundir=${xios_test_suite_repository}/RUN
-  mkdir -p $rundir ; CHMOD  $rundir
-  mkdir -p ${rundir}/test_${xios_machine_name} ; CHMOD ${rundir}/test_${xios_machine_name}
-
-  cp report_${svnR}_${arch}_${mode}.txt ${rundir}/test_${xios_machine_name}/test_${svnR}_${xios_machine_name}_${arch}_${mode}.txt
-
-  CHMOD ${rundir}/test_${xios_machine_name}/test_${svnR}_${xios_machine_name}_${arch}_${mode}.txt
-
-  mkdir -p ${rundir}/def_files ;  CHMOD ${rundir}/RUN/def_files
-  mkdir -p ${rundir}/def_files/${svnR} ;  CHMOD ${rundir}/def_files/${svnR}
-
-  for i in $(ls -d test_*/)
-  do
-    mkdir -p ${rundir}/def_files/${svnR}/${i%%}
-    cp ${i%%}/user_param.json ${rundir}/def_files/${svnR}/${i%%}
-    for j in $(ls -d ${i%%/}/CONFIG_*)
-    do
-      mkdir -p ${rundir}/def_files/${svnR}/${j%%}
-      cp ${j%%}/all_param.def ${rundir}/def_files/${svnR}/${j%%}
-    done
-    CHMOD ${rundir}/def_files
-  done
-
-
-else
-  echo "XIOS Build Failed. Skip Unit Tests"
-fi
-
-
-
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/job_irene_local.sh
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/job_irene_local.sh	(revision 1923)
+++ 	(revision )
@@ -1,43 +1,0 @@
-#!/bin/bash
-######################
-## CURIE   TGCC/CEA ##
-######################
-#MSUB -r XIOS
-#MSUB -o client_output.out    # standard output
-#MSUB -e client_error.err    #error output
-#MSUB -eo
-#MSUB -c 1
-#MSUB -n 48  # Number of MPI tasks (SPMD case) or cores (MPMD case)
-#MSUB -X 
-#MSUB -x 
-#MSUB -T 1800      # Wall clock limit (seconds)
-#MSUB -q skylake           # thin nodes
-#MSUB -A gen0826
-#MSUB -Q test
-#MSUB -m work,scratch
-
-
-#============================= X64_IRENE_prod =============================
-
-
-cd $BRIDGE_MSUB_PWD
-
-export arch=X64_IRENE
-export mode=prod
-
-./run_test_local
-
-
-#============================= X64_IRENE_debug =============================
-
-
-cd $BRIDGE_MSUB_PWD
-
-export arch=X64_IRENE
-export mode=debug
-
-./run_test_local
-
-
-
-
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/job_jeanzay.sh
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/job_jeanzay.sh	(revision 1923)
+++ 	(revision )
@@ -1,43 +1,0 @@
-#!/bin/bash
-export build_dir=xios_test_suite/RUN_TEST_SUITE/build_${arch}_${mode}
-export svnR=$(svn info --show-item revision ../../)
-export ref_location=/gpfswork/rech/psl/rpsl954/cron_xios
-export ref_file=reference.tar.gz
-
-echo "Start Building XIOS ... "
-bash -c "cd ../.. && ./make_xios --arch_path `pwd`/../ARCH --arch ${arch} --${mode} --build_dir ${build_dir} --job 4"
-
-export build_status=$?
-if [[ ${build_status} == 0 ]]
-then
-  echo "XIOS Build Finished. Start Unit Tests"
-  bash ./my_prod.sh
-  rundir=${xios_test_suite_repository}/RUN
-  mkdir -p $rundir ; CHMOD  $rundir
-  mkdir -p ${rundir}/test_${xios_machine_name} ; CHMOD ${rundir}/test_${xios_machine_name}
-
-  cp report_${svnR}_${arch}_${mode}.txt ${rundir}/test_${xios_machine_name}/test_${svnR}_${xios_machine_name}_${arch}_${mode}.txt
-
-  CHMOD ${rundir}/test_${xios_machine_name}/test_${svnR}_${xios_machine_name}_${arch}_${mode}.txt
-
-  mkdir -p ${rundir}/def_files ;  CHMOD ${rundir}/def_files
-  mkdir -p ${rundir}/def_files/${svnR} ;  CHMOD ${rundir}/def_files/${svnR}
-
-  for i in $(ls -d test_*/)
-  do
-    mkdir -p ${rundir}/def_files/${svnR}/${i%%}
-    cp ${i%%}/user_param.json ${rundir}/def_files/${svnR}/${i%%}
-    for j in $(ls -d ${i%%/}/CONFIG_*)
-    do
-      mkdir -p ${rundir}/def_files/${svnR}/${j%%}
-      cp ${j%%}/all_param.def ${rundir}/def_files/${svnR}/${j%%}
-    done
-    CHMOD ${rundir}/def_files
-  done
-
-
-else
-  echo "XIOS Build Failed. Skip Unit Tests"
-fi
-
-
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/job_jeanzay_local.sh
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/job_jeanzay_local.sh	(revision 1923)
+++ 	(revision )
@@ -1,32 +1,0 @@
-#!/bin/bash
-##SBATCH --nodes=2
-#SBATCH --ntasks=32              # Nombre total de processus MPI
-#SBATCH --ntasks-per-node=16
-##SBATCH --cpus-per-task=1
-#SBATCH --hint=nomultithread
-#SBATCH -t 00:10:00              # Temps elapsed maximum d'exÃ©cution
-#SBATCH -o output.out     # Nom du fichier de sortie
-#SBATCH -e error.err     # Nom du fichier d'erreur
-##SBATCH -p cpu_port             # Nom de la partition d'exÃ©cution
-##SBATCH -A sos@cpu
-##SBATCH --distribution=arbitrary
-#SBATCH --account=psl@cpu
-
-ulimit -c 0
-
-cd ${SLURM_SUBMIT_DIR}
-
-#============================= X64_JEANZAY_prod =============================
-
-export arch=X64_JEANZAY
-export mode=prod
-
-time ./run_test_local
-
-
-#============================= X64_JEANZAY_debug =============================
-
-export arch=X64_JEANZAY
-export mode=debug
-
-time ./run_test_local
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/my_run.sh
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/my_run.sh	(revision 1923)
+++ XIOS/trunk/xios_test_suite/TEST_SUITE/my_run.sh	(revision 1924)
@@ -28,6 +28,6 @@
   do
     echo "job" $jobid "pending/running for about" ${i} seconds
-    sleep 5
-    ((i+=5))
+    sleep 30
+    ((i+=30))
     output=$(ccc_mpp | grep ${jobid})
   done
@@ -44,6 +44,6 @@
   do
     echo "job" $jobid "pending/running for about" ${i} seconds
-    sleep 5
-    ((i+=5))
+    sleep 30
+    ((i+=30))
     output=$(squeue -u rpsl954 | grep ${jobid})
   done
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/step1.py
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/step1.py	(revision 1923)
+++ XIOS/trunk/xios_test_suite/TEST_SUITE/step1.py	(revision 1924)
@@ -7,6 +7,6 @@
 import copy
 
-param_list = ["ATMdomain", "UsingServer2", "NumberClients", "NumberServers", "RatioServer2", "NumberPoolsServer2", "Duration", "InfoLevel"]
-param_short_list = ["ATMdom", "Srv2", "NbClnt", "NbSrv", "RatioSrv2", "NbPlSrv2", "Duration", "Info"]
+param_list =       ["DomMask",    "AxisMask", "Domain", "UseServer2", "NumberClients", "NumberServers", "PctServer2", "Duration", "OneSided", "NonDistTran"]
+param_short_list = ["DomMask",    "AxisMask", "Dom",    "Srv2",       "NbClnt",        "NbSrv",         "PctSrv2",    "Duration", "OneSided", "NDtTr"]
 
 mode=os.getenv("mode")
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/test_axis_algo/user_param.json
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/test_axis_algo/user_param.json	(revision 1923)
+++ XIOS/trunk/xios_test_suite/TEST_SUITE/test_axis_algo/user_param.json	(revision 1924)
@@ -1,14 +1,14 @@
 [
 	{
-		"ATMdomain": ["lmdz"],
-		"UsingServer2": ["true"],
+		"Domain": ["lmdz"],
+		"UseServer2": ["true"],
 		"NumberServers": [2, 4],
-		"RatioServer2": [50]
+        "AxisMask": ["false"]
 	},
 	{
-		"UsingServer2": ["true"],
+		"Domain": ["lmdz"],
+		"UseServer2": ["true"],
 		"NumberServers": [6, 8],
-		"ATMdomain": ["lmdz"],
-		"RatioServer2": [50]
+        "AxisMask": ["false"]
 	}
 ]
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/test_domain_algo/user_param.json
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/test_domain_algo/user_param.json	(revision 1923)
+++ XIOS/trunk/xios_test_suite/TEST_SUITE/test_domain_algo/user_param.json	(revision 1924)
@@ -1,14 +1,8 @@
 [
 	{
-		"ATMdomain": ["lmdz"],
-		"UsingServer2": ["true"],
-		"NumberServers": [2, 4],
-		"RatioServer2": [50]
-	},
-	{
-		"UsingServer2": ["true"],
-		"NumberServers": [6, 8],
-		"ATMdomain": ["lmdz"],
-		"RatioServer2": [50]
+		"Domain": ["lmdz"],
+		"NumberServers": [2, 4, 6, 8],
+		"DomMask": ["false"],
+		"AxisMask": ["false"]
 	}
 ]
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/test_function/user_param.json
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/test_function/user_param.json	(revision 1923)
+++ XIOS/trunk/xios_test_suite/TEST_SUITE/test_function/user_param.json	(revision 1924)
@@ -1,14 +1,12 @@
 [
 	{
-		"ATMdomain": ["lmdz"],
-		"UsingServer2": ["true"],
-		"NumberServers": [2, 4],
-		"RatioServer2": [50]
+		"Domain": ["lmdz"],
+		"UseServer2": ["true"],
+		"NumberServers": [2, 4]
 	},
 	{
-		"UsingServer2": ["true"],
-		"NumberServers": [6, 8],
-		"ATMdomain": ["lmdz"],
-		"RatioServer2": [50]
+		"Domain": ["lmdz"],
+		"UseServer2": ["true"],
+		"NumberServers": [6, 8]
 	}
 ]
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/test_grid_algo/user_param.json
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/test_grid_algo/user_param.json	(revision 1923)
+++ XIOS/trunk/xios_test_suite/TEST_SUITE/test_grid_algo/user_param.json	(revision 1924)
@@ -1,14 +1,10 @@
 [
 	{
-		"ATMdomain": ["lmdz"],
-		"UsingServer2": ["true"],
 		"NumberServers": [2, 4],
-		"RatioServer2": [50]
+		"OneSided": ["false"]
 	},
 	{
-		"UsingServer2": ["true"],
 		"NumberServers": [6, 8],
-		"ATMdomain": ["lmdz"],
-		"RatioServer2": [50]
+		"OneSided": ["false"]
 	}
 ]
Index: XIOS/trunk/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param.json
===================================================================
--- XIOS/trunk/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param.json	(revision 1923)
+++ XIOS/trunk/xios_test_suite/TEST_SUITE/test_scalar_algo/user_param.json	(revision 1924)
@@ -1,14 +1,12 @@
 [
 	{
-		"ATMdomain": ["lmdz"],
-		"UsingServer2": ["true"],
+		"Domain": ["lmdz"],
 		"NumberServers": [2, 4],
-		"RatioServer2": [50]
+		"AxisMask": ["false"]
 	},
 	{
-		"UsingServer2": ["true"],
+		"Domain": ["lmdz"],
 		"NumberServers": [6, 8],
-		"ATMdomain": ["lmdz"],
-		"RatioServer2": [50]
+		"AxisMask": ["false"]
 	}
 ]